﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Charting;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for PieGrouping.xaml
    /// </summary>
    public partial class PieGrouping : Window
    {
        public PieGrouping()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(PieGrouping_Loaded);
        }

        void PieGrouping_Loaded(object sender, RoutedEventArgs e)
        {
            List<PieTest> pies = new List<PieTest>();
            pies.Add(new PieTest() { PieID = 1, Baker = "John", Crust = "Corn Meal", Filling = "Chili" });
            pies.Add(new PieTest() { PieID = 2, Baker = "Peter", Crust = "Graham Cracker", Filling = "Cream Cheese" });
            pies.Add(new PieTest() { PieID = 3, Baker = "Paul", Crust = "Graham Cracker", Filling = "Chocolate Cream" });
            pies.Add(new PieTest() { PieID = 4, Baker = "Paul", Crust = "Flour", Filling = "Apple" });

            SeriesMapping map = new SeriesMapping();
            map.SeriesDefinition = new PieSeriesDefinition();
            map.ItemMappings.Add(new ItemMapping() { DataPointMember = DataPointMember.YValue, FieldName = "PiesCount" });
            map.ItemMappings.Add(new ItemMapping() { DataPointMember = DataPointMember.LegendLabel, FieldName = "Baker" });
            RadChart1.SeriesMappings.Add(map);
            var source = pies.GroupBy(pie => pie.Baker).Select(group => new Group() { Baker = group.Key, PiesCount = group.Count() }).ToList();
            RadChart1.ItemsSource = source;
        }

        public class PieTest
        {
            public int PieID { get; set; }
            public string Baker { get; set; }
            public string Crust { get; set; }
            public string Filling { get; set; }
        }

        public class Group
        {
            public string Baker { get; set; }
            public int PiesCount { get; set; }
        }
    }
}
